--- libmp4.0.c	2008-05-23 18:44:19.000000000 -0400
+++ libmp4.c	2009-03-03 23:17:09.000000000 -0500
@@ -76,6 +76,7 @@
 static GThread   *decodeThread;
 GStaticMutex     mutex = G_STATIC_MUTEX_INIT;
 static int       seekPosition = -1;
+static volatile char pause_flag;
 
 void getMP4info(char*);
 int getAACTrack(mp4ff_t *);
@@ -100,6 +101,7 @@
 {
     mp4cfg.file_type = FILE_UNKNOWN;
     seekPosition = -1;
+    pause_flag = 0;
     return;
 }
 
@@ -296,7 +298,7 @@
 
 static void mp4_pause(InputPlayback *playback, short flag)
 {
-    playback->output->pause(flag);
+   pause_flag = flag;
 }
 
 static void mp4_seek(InputPlayback *data, int time)
@@ -542,6 +544,19 @@
             seekPosition = -1;
         }
 
+        if (pause_flag) {
+           playback->output->pause (1);
+           while (pause_flag) {
+              if (seekPosition != -1) {
+                 playback->output->flush (seekPosition * 1000);
+                 sampleID = (long long) seekPosition * samplerate / (framesize - 1);
+                 seekPosition = -1;
+              }
+              g_usleep(50000);
+           }
+           playback->output->pause (0);
+        }
+
         /* Otherwise continue playing */
         buffer=NULL;
         bufferSize=0;
